<?php

/*
  Plugin Name: Hangit
  Plugin URI: http://www.velvary.com.au/vanilla-beans/wordpress/hangit
  Description: Addon for products and posts that would benefit from their featured image being dragged and resized onto background images
  Version: 2.22
  Author: vsmash
  Author URI: http://www.velvary.com.au
  License: GPLv2
 */

// If this file is called directly, abort.
if (!defined('WPINC')) {
    die;
}

if (!defined('VBEANHANGIT_PLUGIN_DIR')) {
    define('VBEANHANGIT_PLUGIN_DIR', plugin_dir_path(__FILE__));
}
if (!defined('VBEANHANGIT_PLUGIN_URL')) {
    define('VBEANHANGIT_PLUGIN_URL', plugin_dir_url(__FILE__));
}
if (!defined('VBEANHANGIT_PLUGIN_FILE')) {
    define('VBEANHANGIT_PLUGIN_FILE', __FILE__);
}
if (!defined('VBEANHANGIT_PLUGIN_VERSION')) {
    define('VBEANHANGIT_PLUGIN_VERSION', '2.22');
}

if (!defined('VBEANHANGIT_BACKGROUNDS')) {
    define('VBEANHANGIT_BACKGROUNDS', 'louvre.jpg|The Louvre|Inside the Louvre in Paris,greenbedroom.jpg|Apartment Room|Apartment Room background for hangit plugin,living-room-wall-colors-photos.jpg|Living Room|Orange Living Room,at-t-stadium.jpg|AT&T Stadium|AT&T Stadium - Arlington Texas,whiteloungeroom.jpg|White Loungeroom setting|Background example for hangit,Mexican_highway.jpg|Mexican Highway|Sign on a Mexican Highway');
}
$dbug = (site_url() == 'https://sandbox.wordpress' || site_url() == 'http://sandbox.wordpress');

if (!defined('VBEANHANGIT_DBUG')) {
    define('VBEANHANGIT_DBUG', $dbug);
}

if(!function_exists('vbean_hangit_splitbackgrounds')){
    function vbean_hangit_splitbackgrounds(){
        $array = explode(',', VBEANHANGIT_BACKGROUNDS);
        $return = array();
        foreach ($array as $a){
            $ia = explode('|', $a);
            array_push($return, $ia);
        }
        return $return;
    }
}


/* ===========================================
  Define Includes
  =========================================== */
$includes = array(
    'functions.php'
);

$frontend_includes = array(
    'wall-placement.php'
);


$adminincludes = array(
    'settings.php'
);

/* ===========================================
  Load Includes
  =========================================== */
// Common
foreach ($includes as $include) {
    require_once( dirname(__FILE__) . '/inc/' . $include );
}
if (is_admin()) {
    //load admin part
    foreach ($adminincludes as $admininclude) {
        require_once( dirname(__FILE__) . '/inc/admin/' . $admininclude );
    }
} else {
    //load front part
    foreach ($frontend_includes as $include) {
        require_once( dirname(__FILE__) . '/inc/' . $include );
    }
}


add_action('admin_menu', 'vbean_hangit_create_menu');







if (!function_exists('vbean_hangit_create_menu')) {






    function vbean_hangit_create_menu() {


        if (empty($GLOBALS['admin_page_hooks']['vanillabeans-settings'])) {
            //create new top-level menu
            add_menu_page('Vanilla Beans', 'Vanilla Beans', 'administrator', 'vanillabeans-settings', 'VanillaBeans\LiveSettings', VBEANHANGIT_PLUGIN_URL . 'vicon.png', 4);
        }



        $vbean_hook = add_submenu_page('vanillabeans-settings', 'Hangit', 'Hangit', 'administrator', __FILE__, 'VanillaBeans\hangit\SettingsPage');


        //call register settings function
        add_action('admin_init', 'VanillaBeans\hangit\RegisterSettings');
    }

}

if(!function_exists('hangit_add_settings_link')){
function hangit_add_settings_link($links) {
    $settings_link = '<a href="admin.php?page=hangit/hangit.php">' . __('Settings') . '</a>';
    array_push($links, $settings_link);
    return $links;
}
}
$plugin = plugin_basename(__FILE__);
add_filter("plugin_action_links_$plugin", 'hangit_add_settings_link');
